Pixel Scrolling

In addition to the default scrolling by rows and columns, SpreadJS provides the option for precise scrolling by pixel horizontally or vertically. This allows cells to be partially visible, which can be useful with large content.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

SpreadJS will enable precision scrolling by pixel when scrollByPixel is true.

    var spread = GC.Spread.Sheets.findControl(document.getElementById('ss'));
    spread.options.scrollByPixel = true;

In addition, you can also define the number of pixels that are scrolled at a time when scrollByPixel is true. The final scrolling pixels are the result of scrolling delta multiplied by scrollPixel.

For example, the scrolling delta is 3, and the scrollPixel is 5, the final scrolling pixels are 15.

    var spread = GC.Spread.Sheets.findControl(document.getElementById('ss'));
    spread.options.scrollByPixel = true;
    spread.options.scrollPixel = 5;

The Worksheet class provides a scroll method to scroll the sheet by specified pixels.

The scroll method has 2 number parameters, vPixels and hPixels.

The vPixels represents the pixels to scroll in vertical direction. The hPixels represents the pixels to scroll in horizontal direction.

When vPixels is positive, worksheet will scroll down; when vPixels is negative, worksheet will scroll up; when vPixels is 0, worksheet won't scroll in vertical direction.

When hPixels is positive, worksheet will scroll right; when hPixels is negative, worksheet will scroll left; when hPixels is 0, worksheet won't scroll in horizontal direction.

When the Workbook’s scrollByPixel option is set to true, the worksheet will scroll to the new top row/left column index and the new top row/left column offset.

When Workbook's option scrollByPixel is false, worksheet will scroll to new top row/left column index, and new top row/left column offset will be always 0.

    var spread = GC.Spread.Sheets.findControl(document.getElementById('ss'));
    spread.options.scrollByPixel = true;
    var sheet = spread.getActiveSheet();
    //This example scrolls down the sheet 10 pixels and scrolls right the sheet 5 pixels.
    sheet.scroll(10, 5);

in TopRowChanged / LeftColumnChanged event, you can use offset attributes to get info of current position in cell.

///* LeftColumnChanged
/**
 * Occurs when the left column changes.
 * @name GC.Spread.Sheets.Worksheet#LeftColumnChanged
 * @event
 * @param {GC.Spread.Sheets.Worksheet} sheet The sheet that triggered the event.
 * @param {string} sheetName The sheet's name.
 * @param {number} oldLeftCol The old left column index.
 * @param {number} newLeftCol The new left column index.
 * @param {number} oldOffset The old left column offset.   //  ===> new attribute
 * @param {number} newOffset The new left column offset.   //  ===> new attribute
///* TopRowChanged
/**
 * Occurs when the top row changes.
 * @name GC.Spread.Sheets.Worksheet#TopRowChanged
 * @event
 * @param {GC.Spread.Sheets.Worksheet} sheet The sheet that triggered the event.
 * @param {string} sheetName The sheet's name.
 * @param {number} oldTopRow The old top row index.
 * @param {number} newTopRow The new top row index.
 * @param {number} oldOffset The old top row offset.      //  ===> new attribute
 * @param {number} newOffset The new top row offset.      //  ===> new attribute

if you want to use the oldOffset/newOffset attributes, you can do like this:

var wb1 = new GC.Spread.Sheets.Workbook(document.getElementById("ss1"));
var wb2 = new GC.Spread.Sheets.Workbook(document.getElementById("ss2"));
wb1.options.scrollByPixel = true;
wb2.options.scrollByPixel = true;

wb1.bind(GC.Spread.Sheets.Events.TopRowChanged, (e, info) => {
  wb2.getActiveSheet().showRow(info.newTopRow);
  wb2.getActiveSheet().scroll(info.newOffset - info.oldOffset, 0);
});

wb1.bind(GC.Spread.Sheets.Events.LeftColumnChanged, (e, info) => {
  wb2.getActiveSheet().showColumn(info.newLeftCol);
  wb2.getActiveSheet().scroll(0, info.newOffset - info.oldOffset);
});

// scroll the wb1
SpreadJS will enable precision scrolling by pixel when scrollByPixel is true. In addition, you can also define the number of pixels that are scrolled at a time when scrollByPixel is true. The final scrolling pixels are the result of scrolling delta multiplied by scrollPixel. For example, the scrolling delta is 3, and the scrollPixel is 5, the final scrolling pixels are 15. The Worksheet class provides a scroll method to scroll the sheet by specified pixels. The scroll method has 2 number parameters, vPixels and hPixels. The vPixels represents the pixels to scroll in vertical direction. The hPixels represents the pixels to scroll in horizontal direction. When vPixels is positive, worksheet will scroll down; when vPixels is negative, worksheet will scroll up; when vPixels is 0, worksheet won't scroll in vertical direction. When hPixels is positive, worksheet will scroll right; when hPixels is negative, worksheet will scroll left; when hPixels is 0, worksheet won't scroll in horizontal direction. When the Workbook’s scrollByPixel option is set to true, the worksheet will scroll to the new top row/left column index and the new top row/left column offset. When Workbook's option scrollByPixel is false, worksheet will scroll to new top row/left column index, and new top row/left column offset will be always 0. in TopRowChanged / LeftColumnChanged event, you can use offset attributes to get info of current position in cell. if you want to use the oldOffset/newOffset attributes, you can do like this:
window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 1 }); initSpread(spread); }; function initSpread(spread) { /* Binding settings */ var scrollByPixel = _getElementById("scrollByPixel"); scrollByPixel.addEventListener("change", function () { spread.options.scrollByPixel = scrollByPixel.checked; }); var scrollPixel = _getElementById("scrollPixel"); _getElementById("setScrollPixel").addEventListener("click", function () { spread.options.scrollPixel = parseInt(scrollPixel.value); }); _getElementById("scroll").addEventListener("click", function () { var vPixels = parseFloat(_getElementById("vPixels").value); var hPixels = parseFloat(_getElementById("hPixels").value); var sheet = spread.getActiveSheet(); sheet.scroll(vPixels, hPixels); }); var intervalID; _getElementById("autoScroll").addEventListener("click", function () { if (intervalID) { window.clearInterval(intervalID); intervalID = null; } var vPixels = parseFloat(_getElementById("vPixels").value); var hPixels = parseFloat(_getElementById("hPixels").value); var interval = parseInt(_getElementById("interval").value); intervalID = setInterval(function () { var sheet = spread.getActiveSheet(); sheet.scroll(vPixels, hPixels); }, interval); }); _getElementById("stopScroll").addEventListener("click", function () { if (intervalID) { window.clearInterval(intervalID); intervalID = null; } }); spread.suspendPaint(); spread.options.scrollByPixel = true; var sheet = spread.getActiveSheet(); //change cells dimensions sheet.setColumnWidth(0, 150); sheet.setColumnWidth(4, 100); sheet.setColumnWidth(5, 430); sheet.setRowHeight(0, 50); sheet.setRowHeight(3, 10); sheet.setRowHeight(10, 100); sheet.setRowHeight(12, 475); sheet.resumePaint(); spread.resumePaint(); } function _getElementById(id){ return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <p>Scroll the spreadsheet to view the pixel scrolling feature. </p> <p>You can also change the number of pixels scrolled below by entering the number and press Set Scroll Pixel.</p> <p>To disable this feature, uncheck the option.</p> <input type="checkbox" id="scrollByPixel" checked="checked" /> <label for="scrollByPixel">Scroll By Pixel</label> </div> <div class="option-row"> <input type="number" id="scrollPixel" value="5" /> <input type="button" id="setScrollPixel" value="Set Scroll Pixel" /> </div> <div class="option-row"> <p>You can also scroll the sheet by specified pixels.</p> <label> <input type="number" id="vPixels" value="1"> vPixels </label> <label> <input type="number" id="hPixels" value="0"> hPixels </label> <input type="button" id="scroll" value="Scroll"> </div> <div class="option-row"> <p>If you invoke the scroll method in a timer, the sheet can be scrolled automatically.</p> <label> <input type="number" id="interval" value="20"> interval(ms) </label> <input type="button" id="autoScroll" value="Automatically Scroll"> <input type="button" id="stopScroll" value="Stop Scroll"> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { margin-bottom: 6px; } input { padding: 3px; margin: 3px; } input[type=number] { width: 40px; } hr { border-color: #fff; opacity: .2; margin-top: 20px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

SpreadJS will enable precision scrolling by pixel when scrollByPixel is true.
In addition, you can also define the number of pixels that are scrolled at a time when scrollByPixel is true.
The final scrolling pixels are the result of scrolling delta multiplied by scrollPixel.
For example, the scrolling delta is 3, and the scrollPixel is 5, the final scrolling pixels are 15.
The Worksheet class provides a scroll method to scroll the sheet by specified pixels.
The scroll method has 2 number parameters, vPixels and hPixels.
The vPixels represents the pixels to scroll in vertical direction.
The hPixels represents the pixels to scroll in horizontal direction.
When vPixels is positive, worksheet will scroll down; when vPixels is negative, worksheet will scroll up; when vPixels is 0, worksheet won't scroll in vertical direction.
When hPixels is positive, worksheet will scroll right; when hPixels is negative, worksheet will scroll left; when hPixels is 0, worksheet won't scroll in horizontal direction.
When the Workbook’s scrollByPixel option is set to true, the worksheet will scroll to the new top row/left column index and the new top row/left column offset.
When Workbook's option scrollByPixel is false, worksheet will scroll to new top row/left column index, and new top row/left column offset will be always 0.
in TopRowChanged / LeftColumnChanged event, you can use offset attributes to get info of current position in cell.
if you want to use the oldOffset/newOffset attributes, you can do like this:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<p>Scroll the spreadsheet to view the pixel scrolling feature. </p>
<p>You can also change the number of pixels scrolled below by entering the number and press Set Scroll
Pixel.</p>
<p>To disable this feature, uncheck the option.</p>
<input type="checkbox" id="scrollByPixel" checked="checked" @change="setScrollByPixel" />
<label for="scrollByPixel">Scroll By Pixel</label>
</div>
<div class="option-row">
<input type="number" id="scrollPixel" value="5" @change="changeScrollPixel" />
<input type="button" id="setScrollPixel" value="Set Scroll Pixel" @click="setScrollPixel" />
</div>
<div class="option-row">
<p>You can also scroll the sheet by specified pixels.</p>
<label>
<input type="number" id="vPixels" value="1" @change="changeVPixels">
vPixels
</label>
<label>
<input type="number" id="hPixels" value="0" @change="changeHPixels">
hPixels
</label>
<input type="button" id="scroll" value="Scroll" @click="scroll">
</div>
<div class="option-row">
<p>If you invoke the scroll method in a timer, the sheet can be scrolled automatically.</p>
<label>
<input type="number" id="interval" value="20" @change="changeInterval">
interval(ms)
</label>
<input type="button" id="autoScroll" value="Automatically Scroll" @click="autoScroll">
<input type="button" id="stopScroll" value="Stop Scroll" @click="stopScroll">
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from "vue";
import "@mescius/spread-sheets-vue";
let spread = null;
const scrollPixel = ref(5);
const vPixels = ref(1);
const hPixels = ref(0);
const interval = ref(20);
let intervalID = 0;
const initSpread = (s) => {
spread = s;
spread.suspendPaint();
spread.options.scrollByPixel = true;
const sheet = spread.getActiveSheet();
// change cells dimensions
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(4, 100);
sheet.setColumnWidth(5, 430);
sheet.setRowHeight(0, 50);
sheet.setRowHeight(3, 10);
sheet.setRowHeight(10, 100);
sheet.setRowHeight(12, 475);
spread.resumePaint();
};
const setScrollByPixel = (e) => {
spread.options.scrollByPixel = e.target.checked;
}
const changeScrollPixel = (e) => {
scrollPixel.value = parseInt(e.target.value);
}
const setScrollPixel = (e) => {
spread.options.scrollPixel = scrollPixel.value;
}
const changeVPixels = (e) => {
vPixels.value = parseFloat(e.target.value);
}
const changeHPixels = (e) => {
hPixels.value = parseFloat(e.target.value);
}
const scroll = (e) => {
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels.value, hPixels.value);
}
const changeInterval = (e) => {
interval.value = parseInt(e.target.value);
}
const autoScroll = (e) => {
if (intervalID) {
window.clearInterval(intervalID);
intervalID = null;
}
intervalID = setInterval(function () {
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels.value, hPixels.value);
}, interval);
}
const stopScroll = (e) => {
if (intervalID) {
window.clearInterval(intervalID);
intervalID = null;
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
margin-bottom: 6px;
}
input {
padding: 3px;
margin: 3px;
}
input[type=number] {
width: 40px;
}
hr {
border-color: #fff;
opacity: .2;
margin-top: 20px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

SpreadJS will enable precision scrolling by pixel when scrollByPixel is true.
In addition, you can also define the number of pixels that are scrolled at a time when scrollByPixel is true.
The final scrolling pixels are the result of scrolling delta multiplied by scrollPixel.
For example, the scrolling delta is 3, and the scrollPixel is 5, the final scrolling pixels are 15.
The Worksheet class provides a scroll method to scroll the sheet by specified pixels.
The scroll method has 2 number parameters, vPixels and hPixels.
The vPixels represents the pixels to scroll in vertical direction.
The hPixels represents the pixels to scroll in horizontal direction.
When vPixels is positive, worksheet will scroll down; when vPixels is negative, worksheet will scroll up; when vPixels is 0, worksheet won't scroll in vertical direction.
When hPixels is positive, worksheet will scroll right; when hPixels is negative, worksheet will scroll left; when hPixels is 0, worksheet won't scroll in horizontal direction.
When the Workbook’s scrollByPixel option is set to true, the worksheet will scroll to the new top row/left column index and the new top row/left column offset.
When Workbook's option scrollByPixel is false, worksheet will scroll to new top row/left column index, and new top row/left column offset will be always 0.
in TopRowChanged / LeftColumnChanged event, you can use offset attributes to get info of current position in cell.
if you want to use the oldOffset/newOffset attributes, you can do like this:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { useState } from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [scrollPixel, setScrollPixel] = useState(5);
const [vPixels, setVPixels] = useState(1);
const [hPixels, setHPixels] = useState(0);
const [interval, setInterval] = useState(20);
const [intervalID, setIntervalID] = useState(0);
const initSpread = (spread) => {
setSpread(spread);
spread.suspendPaint();
spread.options.scrollByPixel = true;
var sheet = spread.getActiveSheet();
//change cells dimensions
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(4, 100);
sheet.setColumnWidth(5, 430);
sheet.setRowHeight(0, 50);
sheet.setRowHeight(3, 10);
sheet.setRowHeight(10, 100);
sheet.setRowHeight(12, 475);
spread.resumePaint();
}
const setScrollByPixel = (e) => {
spread.options.scrollByPixel = e.target.checked;
}
const changeScrollPixel = (e) => {
setScrollPixel(parseInt(e.target.value));
}
const buttonSetScrollPixel = (e) => {
spread.options.scrollPixel = scrollPixel;
}
const changeVPixels = (e) => {
setVPixels(parseFloat(e.target.value));
}
const changeHPixels = (e) => {
setHPixels(parseFloat(e.target.value));
}
const scroll = (e) => {
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels, hPixels);
}
const changeInterval = (e) => {
setInterval(parseInt(e.target.value));
}
const autoScroll = (e) => {
if (intervalID) {
window.clearInterval(intervalID);
setIntervalID(null);
}
const id = window.setInterval(function () {
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels, hPixels);
}, interval);
setIntervalID(id);
}
const stopScroll = (e) => {
if (intervalID) {
window.clearInterval(intervalID);
setIntervalID(null);
}
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<div className="option-row">
<p>Scroll the spreadsheet to view the pixel scrolling feature. </p>
<p>You can also change the number of pixels scrolled below by entering the number and press Set Scroll Pixel.</p>
<p>To disable this feature, uncheck the option.</p>
<input type="checkbox" id="scrollByPixel" defaultChecked="checked" onChange={e => setScrollByPixel(e)} />
<label htmlFor="scrollByPixel">Scroll By Pixel</label>
</div>
<div className="option-row">
<input type="number" id="scrollPixel" defaultValue={5} onChange={e => changeScrollPixel(e)} />
<input type="button" id="setScrollPixel" defaultValue="Set Scroll Pixel" onClick={e => buttonSetScrollPixel(e)} />
</div>
<div className="option-row">
<p>You can also scroll the sheet by specified pixels.</p>
<label>
<input type="number" id="vPixels" defaultValue={1} onChange={e => changeVPixels(e)} />
vPixels
</label>
<label>
<input type="number" id="hPixels" defaultValue={0} onChange={e => changeHPixels(e)} />
hPixels
</label>
<input type="button" id="scroll" defaultValue="Scroll" onClick={e => scroll(e)} />
</div>
<div className="option-row">
<p>If you invoke the scroll method in a timer, the sheet can be scrolled automatically.</p>
<label>
<input type="number" id="interval" defaultValue={20} onChange={e => changeInterval(e)} />
interval(ms)
</label>
<input type="button" id="autoScroll" defaultValue="Automatically Scroll" onClick={e => autoScroll(e)} />
<input type="button" id="stopScroll" defaultValue="Stop Scroll" onClick={e => stopScroll(e)} />
</div>
</div>
</div>;
}
import * as React from 'react';
import { SpreadSheets, Worksheet, Column } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.scrollPixel = 5;
this.vPixels = 1;
this.hPixels = 0;
this.interval = 20;
this.intervalID = 0;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<div className="option-row">
<p>Scroll the spreadsheet to view the pixel scrolling feature. </p>
<p>You can also change the number of pixels scrolled below by entering the number and press Set Scroll Pixel.</p>
<p>To disable this feature, uncheck the option.</p>
<input type="checkbox" id="scrollByPixel" defaultChecked="checked" onChange={e => this.setScrollByPixel(e)} />
<label htmlFor="scrollByPixel">Scroll By Pixel</label>
</div>
<div className="option-row">
<input type="number" id="scrollPixel" defaultValue={5} onChange={e => this.changeScrollPixel(e)} />
<input type="button" id="setScrollPixel" defaultValue="Set Scroll Pixel" onClick={e => this.setScrollPixel(e)} />
</div>
<div className="option-row">
<p>You can also scroll the sheet by specified pixels.</p>
<label>
<input type="number" id="vPixels" defaultValue={1} onChange={e => this.changeVPixels(e)} />
vPixels
</label>
<label>
<input type="number" id="hPixels" defaultValue={0} onChange={e => this.changeHPixels(e)} />
hPixels
</label>
<input type="button" id="scroll" defaultValue="Scroll" onClick={e => this.scroll(e)} />
</div>
<div className="option-row">
<p>If you invoke the scroll method in a timer, the sheet can be scrolled automatically.</p>
<label>
<input type="number" id="interval" defaultValue={20} onChange={e => this.changeInterval(e)} />
interval(ms)
</label>
<input type="button" id="autoScroll" defaultValue="Automatically Scroll" onClick={e => this.autoScroll(e)} />
<input type="button" id="stopScroll" defaultValue="Stop Scroll" onClick={e => this.stopScroll(e)} />
</div>
</div>
</div>;
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.options.scrollByPixel = true;
var sheet = spread.getActiveSheet();
//change cells dimensions
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(4, 100);
sheet.setColumnWidth(5, 430);
sheet.setRowHeight(0, 50);
sheet.setRowHeight(3, 10);
sheet.setRowHeight(10, 100);
sheet.setRowHeight(12, 475);
spread.resumePaint();
}
setScrollByPixel(e) {
let spread = this.spread;
spread.options.scrollByPixel = e.target.checked;
}
changeScrollPixel(e) {
this.scrollPixel = parseInt(e.target.value);
}
setScrollPixel(e) {
let spread = this.spread;
spread.options.scrollPixel = this.scrollPixel;
}
changeVPixels(e) {
this.vPixels = parseFloat(e.target.value);
}
changeHPixels(e) {
this.hPixels = parseFloat(e.target.value);
}
scroll(e) {
let spread = this.spread;
let vPixels = this.vPixels;
let hPixels = this.hPixels;
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels, hPixels);
}
changeInterval(e) {
this.interval = parseInt(e.target.value);
}
autoScroll(e) {
if (this.intervalID) {
window.clearInterval(this.intervalID);
this.intervalID = null;
}
let spread = this.spread;
let vPixels = this.vPixels;
let hPixels = this.hPixels;
let interval = this.interval;
this.intervalID = setInterval(function () {
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels, hPixels);
}, interval);
}
stopScroll(e) {
if (this.intervalID) {
window.clearInterval(this.intervalID);
this.intervalID = null;
}
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
margin-bottom: 6px;
}
input {
padding: 3px;
margin: 3px;
}
input[type=number] {
width: 40px;
}
hr {
border-color: #fff;
opacity: .2;
margin-top: 20px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
export function getData() {
return [{
"Country": "United Kingdom",
"State": "England",
"City": "Basildon",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Manchester",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Newbury",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Kemble",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Headley",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Southampton",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Cheltenham",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Bournemouth",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "Northern Ireland",
"City": "Helens Bay",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "MO",
"City": "Parkville",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "OR",
"City": "Astoria",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AL",
"City": "Cahaba Heights",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Mickleton",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Riverside",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "NJ",
"City": "Clinton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Peoria",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "IL",
"City": "Morton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Flossmoor",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Genoa",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TN",
"City": "Martin",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TN",
"City": "Memphis",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "Brooklyn",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New Rochelle",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "NY",
"City": "Staten Island",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Shavano Park",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Sugar Land",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Lakewood Village",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "ID",
"City": "Eagle",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "UT",
"City": "Salt Lake City",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "Chula Vista",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "CA",
"City": "Los Gatos",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "CA",
"City": "Santa Monica",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "CA",
"City": "Irvine",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "San Francisco",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Delray Beach",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Fort Lauderdale",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "FL",
"City": "Amelia Island",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "FL",
"City": "Coral Gables",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Parkland",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Reston",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AZ",
"City": "Phoenix",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "GA",
"City": "Ball Ground",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "GA",
"City": "Sandy Springs",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "IA",
"City": "Ankeny",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NC",
"City": "Pittsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Beachwood",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Cincinnati",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NH",
"City": "W Lebanon",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "MD",
"City": "Woodsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "Michigan",
"City": "Farmington",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "HI",
"City": "Honolulu",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "CO",
"City": "Englewood",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "KY",
"City": "Owensboro",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Echuca",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Melbourne",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Burpengary",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Gold Coast",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Israel",
"State": "Tel Aviv",
"City": "Tel Aviv",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "France",
"State": "Ile-de-France",
"City": "Chatou",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "France",
"State": "Upper Normandy",
"City": "Rouen",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Brabant",
"City": "Eindhoven",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Holland",
"City": "Badhoevedorp",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Ireland",
"State": "Meath",
"City": "Julianstown",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Cork",
"City": "Ballynora",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Kinsaley",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Rathgar",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Ottawa",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Belleville",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Alliston",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Maple Ridge District Municipality",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Comox",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Tsawwassen",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Canada",
"State": "Saskatchewan",
"City": "Prince Albert",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Red Deer",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Okotoks",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "India",
"State": "Andhra Pradesh",
"City": "Hyderabad",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "South Africa",
"State": "Gauteng",
"City": "Roodepoort",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Finland",
"State": "Ita-Suomen Laani",
"City": "Kuopio",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Switzerland",
"State": "Geneve",
"City": "Vesenaz",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Lausanne",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Morges",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Denmark",
"State": "Frederiksborg",
"City": "Helsingor",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Denmark",
"State": "Kobenhavn",
"City": "Kobenhavn",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Denmark",
"State": "Storstrom",
"City": "Nakskov",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Belgium",
"State": "Brussels (Bruxelles)",
"City": "Brussels",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Sweden",
"State": "Stockholm",
"City": "Saltsjobaden",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Norway",
"State": "Rogaland",
"City": "Stavanger",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Norway",
"State": "Oslo",
"City": "Oslo",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Luxembourg",
"State": "Luxembourg",
"City": "Gasperich",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Italy",
"State": "Lombardy",
"City": "Milan",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Germany",
"State": "Nordrhein-Westfalen",
"City": "Telgte",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Moldova",
"State": "Chisinau",
"City": "Bubuieci",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Spain",
"State": "Murcia",
"City": "La Alberca",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Arab Emirates",
"State": "Dubayy",
"City": "Jumeira",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Bahrain",
"State": "Al Manamah",
"City": "Al 'Adliyah",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}];
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

SpreadJS will enable precision scrolling by pixel when scrollByPixel is true.
In addition, you can also define the number of pixels that are scrolled at a time when scrollByPixel is true.
The final scrolling pixels are the result of scrolling delta multiplied by scrollPixel.
For example, the scrolling delta is 3, and the scrollPixel is 5, the final scrolling pixels are 15.
The Worksheet class provides a scroll method to scroll the sheet by specified pixels.
The scroll method has 2 number parameters, vPixels and hPixels.
The vPixels represents the pixels to scroll in vertical direction.
The hPixels represents the pixels to scroll in horizontal direction.
When vPixels is positive, worksheet will scroll down; when vPixels is negative, worksheet will scroll up; when vPixels is 0, worksheet won't scroll in vertical direction.
When hPixels is positive, worksheet will scroll right; when hPixels is negative, worksheet will scroll left; when hPixels is 0, worksheet won't scroll in horizontal direction.
When the Workbook’s scrollByPixel option is set to true, the worksheet will scroll to the new top row/left column index and the new top row/left column offset.
When Workbook's option scrollByPixel is false, worksheet will scroll to new top row/left column index, and new top row/left column offset will be always 0.
in TopRowChanged / LeftColumnChanged event, you can use offset attributes to get info of current position in cell.
if you want to use the oldOffset/newOffset attributes, you can do like this:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import { getData } from './app.data';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = false;
scrollPixel = 5;
vPixels = 1;
hPixels = 0;
interval = 20;
intervalID = 0;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
spread.options.scrollByPixel = true;
var sheet = spread.getActiveSheet();
//change cells dimensions
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(4, 100);
sheet.setColumnWidth(5, 430);
sheet.setRowHeight(0, 50);
sheet.setRowHeight(3, 10);
sheet.setRowHeight(10, 100);
sheet.setRowHeight(12, 475);
spread.resumePaint();
}
setScrollByPixel(e: any) {
let spread = this.spread;
spread.options.scrollByPixel = e.target.checked;
}
changeScrollPixel(e: any) {
this.scrollPixel = parseInt(e.target.value);
}
setScrollPixel(e: any) {
let spread = this.spread;
spread.options.scrollPixel = this.scrollPixel;
}
changeVPixels(e: any) {
this.vPixels = parseFloat(e.target.value);
}
changeHPixels(e: any) {
this.hPixels = parseFloat(e.target.value);
}
scroll(e: any) {
let spread = this.spread;
let vPixels = this.vPixels;
let hPixels = this.hPixels;
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels, hPixels);
}
changeInterval(e: any) {
this.interval = parseInt(e.target.value);
}
autoScroll(e: any) {
if (this.intervalID) {
window.clearInterval(this.intervalID);
this.intervalID = null;
}
let spread = this.spread;
let vPixels = this.vPixels;
let hPixels = this.hPixels;
let interval = this.interval;
this.intervalID = setInterval(function () {
let sheet = spread.getActiveSheet();
sheet.scroll(vPixels, hPixels);
}, interval);
}
stopScroll(e: any) {
if (this.intervalID) {
window.clearInterval(this.intervalID);
this.intervalID = null;
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<p>Scroll the spreadsheet to view the pixel scrolling feature. </p>
<p>You can also change the number of pixels scrolled below by entering the number and press Set Scroll Pixel.</p>
<p>To disable this feature, uncheck the option.</p>
<input type="checkbox" id="scrollByPixel" checked="checked" (change)="setScrollByPixel($event)"/>
<label for="scrollByPixel">Scroll By Pixel</label>
</div>
<div class="option-row">
<input type="number" id="scrollPixel" value="5" (change)="changeScrollPixel($event)"/>
<input type="button" id="setScrollPixel" value="Set Scroll Pixel" (click)="setScrollPixel($event)"/>
</div>
<div class="option-row">
<p>You can also scroll the sheet by specified pixels.</p>
<label>
<input type="number" id="vPixels" value="1" (change)="changeVPixels($event)">
vPixels
</label>
<label>
<input type="number" id="hPixels" value="0" (change)="changeHPixels($event)">
hPixels
</label>
<input type="button" id="scroll" value="Scroll" (click)="scroll($event)">
</div>
<div class="option-row">
<p>If you invoke the scroll method in a timer, the sheet can be scrolled automatically.</p>
<label>
<input type="number" id="interval" value="20" (change)="changeInterval($event)">
interval(ms)
</label>
<input type="button" id="autoScroll" value="Automatically Scroll" (click)="autoScroll($event)">
<input type="button" id="stopScroll" value="Stop Scroll" (click)="stopScroll($event)">
</div>
</div>
</div>
export function getData() {
return [{
"Country": "United Kingdom",
"State": "England",
"City": "Basildon",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Manchester",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Newbury",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Kemble",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Headley",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Southampton",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Cheltenham",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Bournemouth",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "Northern Ireland",
"City": "Helens Bay",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "MO",
"City": "Parkville",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "OR",
"City": "Astoria",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AL",
"City": "Cahaba Heights",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Mickleton",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Riverside",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "NJ",
"City": "Clinton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Peoria",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "IL",
"City": "Morton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Flossmoor",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Genoa",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TN",
"City": "Martin",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TN",
"City": "Memphis",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "Brooklyn",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New Rochelle",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "NY",
"City": "Staten Island",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Shavano Park",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Sugar Land",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Lakewood Village",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "ID",
"City": "Eagle",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "UT",
"City": "Salt Lake City",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "Chula Vista",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "CA",
"City": "Los Gatos",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "CA",
"City": "Santa Monica",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "CA",
"City": "Irvine",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "San Francisco",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Delray Beach",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Fort Lauderdale",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "FL",
"City": "Amelia Island",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "FL",
"City": "Coral Gables",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Parkland",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Reston",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AZ",
"City": "Phoenix",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "GA",
"City": "Ball Ground",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "GA",
"City": "Sandy Springs",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "IA",
"City": "Ankeny",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NC",
"City": "Pittsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Beachwood",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Cincinnati",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NH",
"City": "W Lebanon",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "MD",
"City": "Woodsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "Michigan",
"City": "Farmington",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "HI",
"City": "Honolulu",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "CO",
"City": "Englewood",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "KY",
"City": "Owensboro",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Echuca",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Melbourne",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Burpengary",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Gold Coast",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Israel",
"State": "Tel Aviv",
"City": "Tel Aviv",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "France",
"State": "Ile-de-France",
"City": "Chatou",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "France",
"State": "Upper Normandy",
"City": "Rouen",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Brabant",
"City": "Eindhoven",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Holland",
"City": "Badhoevedorp",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Ireland",
"State": "Meath",
"City": "Julianstown",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Cork",
"City": "Ballynora",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Kinsaley",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Rathgar",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Ottawa",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Belleville",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Alliston",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Maple Ridge District Municipality",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Comox",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Tsawwassen",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Canada",
"State": "Saskatchewan",
"City": "Prince Albert",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Red Deer",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Okotoks",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "India",
"State": "Andhra Pradesh",
"City": "Hyderabad",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "South Africa",
"State": "Gauteng",
"City": "Roodepoort",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Finland",
"State": "Ita-Suomen Laani",
"City": "Kuopio",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Switzerland",
"State": "Geneve",
"City": "Vesenaz",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Lausanne",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Morges",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Denmark",
"State": "Frederiksborg",
"City": "Helsingor",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Denmark",
"State": "Kobenhavn",
"City": "Kobenhavn",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Denmark",
"State": "Storstrom",
"City": "Nakskov",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Belgium",
"State": "Brussels (Bruxelles)",
"City": "Brussels",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Sweden",
"State": "Stockholm",
"City": "Saltsjobaden",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Norway",
"State": "Rogaland",
"City": "Stavanger",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Norway",
"State": "Oslo",
"City": "Oslo",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Luxembourg",
"State": "Luxembourg",
"City": "Gasperich",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Italy",
"State": "Lombardy",
"City": "Milan",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Germany",
"State": "Nordrhein-Westfalen",
"City": "Telgte",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Moldova",
"State": "Chisinau",
"City": "Bubuieci",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Spain",
"State": "Murcia",
"City": "La Alberca",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Arab Emirates",
"State": "Dubayy",
"City": "Jumeira",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Bahrain",
"State": "Al Manamah",
"City": "Al 'Adliyah",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}];
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
margin-bottom: 6px;
}
input {
padding: 3px;
margin: 3px;
}
input[type=number] {
width: 40px;
}
hr {
border-color: #fff;
opacity: .2;
margin-top: 20px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);